import { Doc, Editor, KeyMap, PositionConstructor as Pos } from "codemirror";
declare type CodeMirrorConfigMouseFn = (cm: Editor, pos: Pos) => {
    from: Pos;
    to: Pos;
};
export declare type CodeMirrorOptions = {
    value?: string | Doc;
    mode?: string | {
        [k: string]: any;
        name: string;
    };
    lineSeparator?: string;
    theme?: string;
    indentUnit?: number;
    smartIndent?: boolean;
    tabSize?: number;
    indentWithTabs?: boolean;
    electricChars?: boolean;
    specialChars?: RegExp;
    specialCharPlaceHolder?: (c: string) => Element;
    direction?: 'ltr' | 'rtl';
    rtlMoveVisually?: boolean;
    keyMap?: string;
    extraKeys?: KeyMap;
    configureMouse?: (cm: Editor, repeat: 'single' | 'double' | 'triple', event: Event) => {
        unit?: "char" | "word" | "line" | "rectangle" | CodeMirrorConfigMouseFn;
        extend?: boolean;
        addNew?: boolean;
        moveOnDrag?: boolean;
    };
    lineWrapping?: boolean;
    lineNumbers?: boolean;
    firstLineNumber?: number;
    lineNumberFormatter?: (line: number) => string;
    gutters?: Array<string>;
    fixedGutter?: boolean;
    scrollbarStyle?: string;
    coverGutterNextToScrollbar?: boolean;
    inputStyle?: string;
    readOnly?: boolean | string;
    showCursorWhenSelecting?: boolean;
    lineWiseCopyCut?: boolean;
    pasteLinesPerSelection?: boolean;
    selectionsMayTouch?: boolean;
    undoDepth?: number;
    historyEventDelay?: number;
    tabIndex?: number;
    autoFocus?: boolean;
    phrases?: object;
    dragDrop?: boolean;
    allowDropFileTypes?: Array<string>;
    cursorBlinkRate?: number;
    cursorScrollMargin?: number;
    cursorHeight?: number;
    resetSelectionOnContextMenu?: boolean;
    workTime?: number;
    workDelay?: number;
    pollInterval?: number;
    flattenSpans?: boolean;
    addModeClass?: boolean;
    maxHighlightLength?: number;
    viewportMargin?: number;
};
export declare const KeyNames: {
    3: string;
    8: string;
    9: string;
    13: string;
    16: string;
    17: string;
    18: string;
    19: string;
    20: string;
    27: string;
    32: string;
    33: string;
    34: string;
    35: string;
    36: string;
    37: string;
    38: string;
    39: string;
    40: string;
    44: string;
    45: string;
    46: string;
    59: string;
    61: string;
    91: string;
    92: string;
    93: string;
    106: string;
    107: string;
    109: string;
    110: string;
    111: string;
    127: string;
    145: string;
    173: string;
    186: string;
    187: string;
    188: string;
    189: string;
    190: string;
    191: string;
    192: string;
    219: string;
    220: string;
    221: string;
    222: string;
    63232: string;
    63233: string;
    63234: string;
    63235: string;
    63272: string;
    63273: string;
    63275: string;
    63276: string;
    63277: string;
    63302: string;
};
export declare const props: string[];
export declare const events: string[];
export {};
