import { EditorFromTextArea } from 'codemirror';
import 'codemirror/lib/codemirror.css';
import ResizeSensor from 'css-element-queries/src/ResizeSensor';
import Vue from 'vue';
import { Marker, MarkerElement, TrackedMarkers } from "../types";
import { WatchAllCallback } from "../VueWatchAll";
import { CodeMirrorOptions } from './CodeMirrorTypes';
export default class VueCodeMirror extends Vue {
    $refs: {
        textarea: HTMLTextAreaElement;
    };
    content: string;
    cm?: EditorFromTextArea;
    markers: Array<Marker>;
    currentMarkers: TrackedMarkers;
    parentResizeSensor?: ResizeSensor;
    value: string;
    lineSeparator: string | undefined;
    xClass: string | undefined;
    theme: string;
    mode: string;
    indentUnit: number | undefined;
    smartIndent: boolean | undefined;
    tabSize: number | undefined;
    indentWithTabs: boolean | undefined;
    electricChars: boolean | undefined;
    specialChars: RegExp | undefined;
    specialCharPlaceHolder: Function | undefined;
    direction: string | undefined;
    rtlMoveVisually: boolean | undefined;
    keyMap: string | undefined;
    extraKeys: Object | undefined;
    lineWrapping: boolean | undefined;
    lineNumbers: boolean | undefined;
    gutters: {}[] | undefined;
    fixedGutter: boolean | undefined;
    scrollbarStyle: string | undefined;
    coverGutterNextToScrollbar: boolean | undefined;
    inputStyle: string;
    readOnly: boolean | undefined;
    showCursorWhenSelecting: boolean | undefined;
    lineWiseCopyCut: boolean | undefined;
    pasteLinesPerSelection: boolean | undefined;
    selectionsMayTouch: boolean | undefined;
    undoDepth: number | undefined;
    historyEventDelay: number | undefined;
    tabIndex: number | undefined;
    autoFocus: boolean | undefined;
    phrases: Object | undefined;
    dragDrop: boolean | undefined;
    allowDropFileTypes: {}[] | undefined;
    cursorBlinkRate: number | undefined;
    cursorScrollMargin: number | undefined;
    cursorHeight: number | undefined;
    viewportMargin: number;
    placeholder: string;
    onMarkersChanged(): void;
    created(): void;
    mounted(): void;
    trackParentSize(): void;
    readonly options: CodeMirrorOptions;
    $watchAll(props: string[], callback: WatchAllCallback): void;
    watchOptions(): void;
    addEventListeners(): void;
    addMarker(line: number, gutter: string, m?: MarkerElement): void;
    clearGutter(gutter: string): void;
    removeMarker(line: number, gutter: string): void;
    refresh(): void;
    valueChanged(): void;
    modeChanged(): void;
    themeChanged(): void;
    contentChanged(): void;
    loadMode(): void;
    loadTheme(): void;
    setSize(width: number, height: number): void;
}
